config/routes.rb
Rails.application.routes.draw do
  get 'password_resets/new'
  get 'password_resets/edit'
  scope '(:locale)', locale: /en|vi/ do
    root 'static_pages#home'
    get '/contact', to: 'static_pages#contact'
    get '/signup', to: 'users#new'
    get '/news', to: 'news#index'

    get '/login', to: 'sessions#new'
    post '/login', to: 'sessions#create'
    get '/logout', to: 'sessions#destroy'

    resources :users, only: %i[new create show]
    resources :account_activations, only: :edit
    resources :password_resets, only: %i[new create edit update]
    resources :news
    resources :comments
    resources :categories
    resources :likes
    resources :like_comments
  end
end

app/models/new.rb
class New < ApplicationRecord
  has_many :comment, dependent: :destroy
  has_many :likes, dependent: :destroy
  belongs_to :user
  belongs_to :category
  has_one_attached :thump
  scope :newest, -> { order(created_at: :desc) }
  # validates :user_id, presence: true
  validates :title, presence: true, length: { maximum: Settings.validate.new.max_length_title }
  validates :content, presence: true, length: { maximum: Settings.validate.new.max_length_content }
  validates :thump,
            presence: true,
            content_type: { content_type: Settings.validate.new.validate_image },
            size: { less_than: 1.megabyte }
end

app/controllers/news_controller.rb
class NewsController < ApplicationController
  before_action :find_new, only: %i[edit update show destroy]
  attr_accessor :title, :content, :thump, :name, :category_id, :id

  before_action :category_all, only: %i[index edit update new create]
  before_action :user_all, only: :index

  # new
  def index
    @news_banner = New.limit(5)
    @news = if params[:key_word] || params[:category_id] || params[:user_id]
              New.where('title LIKE ?', "%#{params[:key_word]}%").where('category_id = ?', params[:category_id]).where(
                'user_id = ?', params[:user_id]
              )
            else
              New.all
            end
  end

  def new
    @new = New.new
  end

  def create
    @new = current_user.new.build(new_params)
    if @new.save
      flash[:success] = t 'news.create.created_successfully'
      redirect_to news_path
    else
      flash[:danger] = t 'news.create.created_fail'
      render 'news/new'
    end
  end

  def edit; end

  def update
    if @new_show.update(new_params)
      flash[:success] = t 'common.updated_successfully'
      redirect_to news_path
    else
      render :'news/edit'
    end
  end

  def show
    @like = Like.new
    @like_comment = LikeComment.new
    @comment = Comment.new
  end

  def destroy
    @new_show.destroy
    flash[:success] = t 'common.deleted_successfully'
    redirect_back(fallback_location: root_path)
  end

  private

  # new
  def new_params
    params.require(:new).permit(:title, :content, :thump, :category_id, :key_word, :user_id)
  end

  def find_new
    @new_show = New.find_by(id: params[:id])
  end

  def find_category(category_id)
    @category = Category.find_by(id: category_id)
  end

  def category_all
    @categories = Category.all
  end

  def user_all
    @user = User.all
  end

  # comments
  def comment_params
    params.require(:comment).permit(:comment, :new_id)
  end
end

app/helpers/news_helper.rb
module NewsHelper
end

app/views/news/_news_banner.html.erb
<% @news_banner.each do |i| %>
  <% if i.thump.attached? %>
    <div class="swiper-slide swiper_slide_banner">
      <div class="banner_cmt_likes">
        <div class="banner_likes">Likes: <%= i.likes.count %></div>
        <div class="banner_cmt">Bình luận: <%= i.comment.count %></div>
      </div>
      <%= link_to image_tag(i.thump), "/#{locale}/news/#{i.id}" %>
      <div class="swiper_title">
        <%= link_to i.title, "/#{locale}/news/#{i.id}" %></div>
    </div>
  <% end %>
<% end %>

app/views/news/edit.html.erb
<% provide :title, 'Update news' %>
<h1><%= t "news.edit.title" %></h1>
<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <% if @new_show %>
      <%= form_for(@new_show) do |f| %>
        <%= render 'shared/error_edit_news_messages' %>
        <%= f.label :title %>
        <%= f.text_field :title, class: 'form-control' %>
        <%= f.label :content %>
        <%= f.text_area :content, class: 'form-control content' %>
        <%= f.label :image %>
        <%= f.file_field :thump %>
        <%= f.label :category_id %>
        <% if @categories %>
          <%= f.collection_select :category_id, @categories, :id, :name %>
        <% end %>
        <%= f.submit t("news.index.edit"), class: "btn btn-primary" %>
      <% end %>
    <% end %>
  </div>
</div>

app/views/news/index.html.erb
<% provide :title, 'Index news' %>
<div class="show-news">
  <%= link_to "<button>Thêm mới tin tức</button>".html_safe, logged_in? ? new_news_path : login_path %>
  <div class="tag_new">
    <%= t ".hot_news" %>
  </div>
  <div class="swiper mySwiper">
    <div class="swiper-wrapper">
      <% if @news_banner.empty? %>
        <div class="notification"><%= t "news.common.no_news" %></div>
      <% end %>
      <% if @news_banner.empty? == false %>
        <%= render 'news_banner' %>
      <% end %>
    </div>
    <div class="swiper-pagination"></div>
  </div>

  <div class="search_new">
    <%= form_for(news_path, method: :get) do |f| %>
      <div class="filter_input">
        <%= text_field_tag :key_word, params[:key_word], class: "input_search" %>
        <% if @categories %>
          <%= select_tag :category_id, options_from_collection_for_select(@categories, :id, :name, params[:category_id])%>
        <% end %>
        <% if @user %>
          <%= select_tag :user_id, options_from_collection_for_select(@user, :id, :name, params[:user_id])%>
        <% end %>
        <%= submit_tag 'Search', class: "button_search"  %>
      </div>
    <% end %>
  </div>

  <div class="tag_new">
    <%= t ".filter_new" %>
  </div>
  <div class="swiperC mySwiperC">
    <div class="swiper-wrapper">
      <%# if @new.count == 0 %>
<!--        <div class="notification"><%#= t "news.common.no_news" %></div>-->
      <%# end %>
      <% if @news.count > 0 %>
        <% @news.each do |c| %>
          <% if c.thump.attached? %>
            <div class="swiper-slide swiper-slideC">
              <div class="swiper-img"><%= link_to image_tag(c.thump), "/#{locale}/news/#{c.id}" %></div>
              <div class="swiper_title">
                <%= link_to c.title, "/#{locale}/news/#{c.id}" %></div>
            </div>
          <% end %>
        <% end %>
      <% end %>
    </div>
    <div class="swiper-pagination"></div>
  </div>

  <%# if Category.all %>
  <%# Category.all.each do |i| %>
  <!--      <div class="tag_new">-->
  <%#= i.name %>
  <!--      </div>-->
  <%# if i.new.count == 0 %>
  <!--        <div class="notification"><%#= t "news.common.no_news" %></div>-->
  <%# end %>
  <%# if i.new.count > 0 %>
  <!--        <div class="swiperC mySwiperC">-->
  <!--          <div class="swiper-wrapper">-->
  <%# i.new.each do |c| %>
  <%# if c.thump.attached? %>
  <!--                <div class="swiper-slide swiper-slideC">-->
  <!--                  <div class="swiper-img"><%#= link_to image_tag(c.thump) , "/#{locale}/news/#{c.id}" %></div>-->
  <!--                  <div class="swiper_title">-->
  <!--                    <%#= link_to c.title , "/#{locale}/news/#{c.id}" %></div>-->
  <!--                </div>-->
  <%# end %>
  <%# end %>
  <!--          </div>-->
  <!--          <div class="swiper-pagination"></div>-->
  <!--        </div>-->
  <%# end %>
  <%# end %>
  <%# end %>
</div>

<!-- Swiper JS -->
<script src="https://unpkg.com/swiper/swiper-bundle.min.js"></script>

<!-- Initialize Swiper -->
<script>
    var swiper = new Swiper(".mySwiper", {
        pagination: {
            el: ".swiper-pagination",
            clickable: true,
        },
    });

    var swiperC = new Swiper(".mySwiperC", {
        slidesPerView: 3,
        spaceBetween: 30,
        pagination: {
            el: ".swiper-pagination",
            clickable: true,
        },
    });
</script>

app/views/news/new.html.erb
<% provide :title, 'Create news' %>
<h1><%= t "news.create.title" %></h1>
<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <% if @new %>
      <%= form_for(@new) do |f| %>
        <%= render 'shared/error_news_messages' %>
        <%= f.label :title %>
        <%= f.text_field :title, class: 'form-control' %>
        <%= f.label :content %>
        <%= f.text_area :content, class: 'form-control content' %>
        <%= f.label :image %>
        <%= f.file_field :thump %>
        <%= f.label :category_id %>
        <% if @categories %>
          <%= f.collection_select :category_id, @categories, :id, :name %>
        <% end %>
        <%= f.submit t("news.index.create"), class: "btn btn-primary" %>
      <% end %>
    <% end %>
  </div>
</div>

app/views/news/show.html.erb
<% provide :title, @new_show&.title %>
<div class="container">
  <% if @new_show&.thump.attached? %>
    <div class="swiper-slide swiper_slide_banner">
      <%= image_tag @new_show&.thump %>
      <div class="swiper_title_detail">
        <%= @new_show&.title %></div>
    </div>
    <div class="swiper_content_detail">
      <%= @new_show&.content %>
      <div class="edit_or_delete">
        <div><%= t "comments.show.post_day" %><%= @new_show&.created_at %></div>
        <div><%= t "news.index.author" %><%= User.find_by(id: @new_show&.user_id).name %></div>
      </div>
    </div>
  <% end %>
  <div class="comment_read">
    <% if @like %>
      <%= form_for(@like) do |f| %>
        <%= f.text_field :new_id, value: @new_show.id, class: "d-none" %>
        <%= f.text_field :user_id, value: session[:user_id], class: "d-none" %>
        <div class="button-like-new">
          <% if logged_in? %>
            <% if Like.find_by(user_id: session[:user_id], new_id: @new_show.id) == nil %>
              <%= f.submit "Thích bài viết", class: "btn btn-primary like-button" %>
            <% end %>
          <% end %>
        </div>
      <% end %>
      <% if Like.find_by(user_id: session[:user_id], new_id: @new_show.id) %>
        <%= button_to "Bỏ thích bài viết", "/#{locale}/likes/#{Like.find_by(user_id: session[:user_id], new_id: @new_show.id).id}", method: :delete,
                      data: { confirm: t("common.you_sure?") }, class: "btn btn-primary unlike-button" %>
      <% end %>
      <% if Like.find_by(user_id: session[:user_id], new_id: @new_show.id) == nil %>
        <div class="count-likes"><%= @new_show.likes.count %> Likes</div>
      <% end %>
      <% if Like.find_by(user_id: session[:user_id], new_id: @new_show.id) %>
        <div class="counted-likes"><%= @new_show.likes.count %> Likes</div>
      <% end %>
    <% end %>
    <%= link_to "<button>Thêm bình luận</button>".html_safe, logged_in? ? new_comment_path(new_id: @new_show.id) : login_path %>
    <% @new_show.comment.each do |i| %>
      <div class="comment_area">
        <div class="comment_author">
          <%= gravatar_for User.find_by(id: i.user_id) %>
          <br>
          <%= User.find_by(id: i.user_id).name %>
        </div>
        <div class="comment_element">
          <div class="comment_content"><%= i.comment %></div>

          <div class="d-flex">
            <% if @like_comment %>
              <%= form_for(@like_comment) do |f| %>
                <%= f.text_field :comment_id, value: i.id, class: "d-none" %>
                <%= f.text_field :user_id, value: session[:user_id], class: "d-none" %>
                <div class="button-like-new">
                  <% if logged_in? %>
                    <% if LikeComment.find_by(user_id: session[:user_id], comment_id: i.id) == nil %>
                      <%= f.submit "Thích bình luận", class: "btn btn-primary like-button" %>
                    <% end %>
                  <% end %>
                </div>
              <% end %>
              <% if LikeComment.find_by(user_id: session[:user_id], comment_id: i.id) %>
                <%= button_to "Bỏ thích bình luận", "/#{locale}/like_comments/#{LikeComment.find_by(user_id: session[:user_id], comment_id: i.id).id}", method: :delete,
                              data: { confirm: t("common.you_sure?") }, class: "btn btn-primary unlike-button" %>
              <% end %>
              <% if LikeComment.find_by(user_id: session[:user_id], comment_id: i.id) == nil %>
                <div class="count-likes"><%= i.like_comments.count %> Likes</div>
              <% end %>
              <% if LikeComment.find_by(user_id: session[:user_id], comment_id: i.id) %>
                <div class="counted-likes"><%= i.like_comments.count %> Likes</div>
              <% end %>
            <% end %>
          </div>

          <div class="edit_or_delete">
            <div><%= t "comments.show.post_day" %><%= i.created_at %></div>
            <% if logged_in? && session[:user_id] == i.user_id %>
              <div><%= link_to t("common.edit"), logged_in? ? edit_comment_url(id: i.id, new_id: @new_show.id) : login_path %></div>
              <div><%= button_to t("common.delete"), logged_in? ? "/#{locale}/comments/#{i.id}" : login_path, method: :delete,
                                 data: { confirm: t("common.you_sure?") } %></div>
            <% end %>
          </div>
        </div>
        <br>
      </div>
    <% end %>
  </div>
</div>